
<script>
  import {scaleLinear} from 'd3-scale';
  import {scaleBand} from 'd3-scale';
  import {axisBottom} from 'd3-axis';
  import {axisLeft} from 'd3-axis';
  import {select} from 'd3-selection';

  // Dimensions
  const width = 600;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 30, left: 60 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // array
  const data = [
    { service: "Netflix", viewers: 2.9 },
    { service: "Amazon Prime Video", viewers: 1.3 },
    { service: "Disney+", viewers: 2.1 },
    { service: "Hulu", viewers: 0.9 },
    { service: "Apple TV", viewers: 1.1 },
    { service: "Rakuten", viewers: 0.4 }
  ];
  const class_serv=data.map(d=>d.service)
  const scale_x=scaleBand()
  .range([0,innerWidth])
  .domain(class_serv);
  const scale_y=scaleLinear()
  .domain([0,3])
  .range([innerHeight,0]);

  function yaxis_cust(element){
    let yaxis=axisLeft(scale_y);
    select(element).call(yaxis);
 }

 function xaxis_cust(element){
    let xaxis=axisBottom(scale_x);
    select(element).call(xaxis);
 }

</script>

<svg viewbox="0 0 {width} {height}" style="max-width: {width}px">
  <text  x=0 y=0 transform=" translate(25,175) rotate(270)" fill="currentColor" style="font-size:0.8em;">Viewers (Million) </text>
  <g transform={`translate(${margin.left},${margin.top})`}>
    
    {#each data as datapoint}
    <rect x={scale_x(datapoint.service)+10} y={scale_y(+datapoint.viewers)} width="75" height={innerHeight-scale_y(+datapoint.viewers)} fill="steelblue"/>
    {/each}
  </g>
  <g transform="translate({margin.left},{margin.top})" use:yaxis_cust>
  </g>
  <g transform="translate({margin.left},{innerHeight+margin.top})" use:xaxis_cust>
  </g>
</svg>